package com.googlecode.mycontainer.commons.file;

import java.util.Properties;

import com.googlecode.mycontainer.commons.config.PropertyConfig;

public class ContentTypeUtil {

	private static ContentTypeUtil me;

	private final Properties props;

	private ContentTypeUtil() {
		props = PropertyConfig.instance().getConfig(getClass());
	}

	private static ContentTypeUtil instance() {
		if (me == null) {
			me = new ContentTypeUtil();
		}
		return me;
	}

	public static String getContentTypeByPath(String ext) {
		ext = PathUtil.getExtention(ext);
		return getContentType(ext);
	}

	public static String getContentType(String ext) {
		Properties config = instance().getProperties();
		if (ext == null) {
			return config.getProperty("all");
		}
		String ret = config.getProperty(ext);
		if (ret == null) {
			return config.getProperty("all");
		}
		return ret;
	}

	private Properties getProperties() {
		return props;
	}

}
