package com.googlecode.mycontainer.commons.reflect;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

public class InvocationHandlerAdapter implements InvocationHandler {

	private ObjectReflect objectReflect;

	public InvocationHandlerAdapter(Object impl) {
		objectReflect = new ObjectReflect(impl);
	}

	public Object invoke(Object proxy, Method method, Object[] args)
			throws Throwable {
		Method implMethod = objectReflect.getMethod(method.getName(),
				method.getParameterTypes());

		return objectReflect.invoke(implMethod, args);
	}

	@SuppressWarnings("unchecked")
	public <T> T createProxy(Class<T> clazz) {
		return (T) createProxy(new Class<?>[] { clazz });
	}

	public Object createProxy(Class<?>[] classes) {
		return Proxy.newProxyInstance(getClass().getClassLoader(), classes,
				this);
	}

}
