package com.googlecode.mycontainer.commons.rhino;

import java.net.URL;

import org.mozilla.javascript.UniqueTag;

import com.googlecode.mycontainer.commons.file.PathUtil;

public class RhinoBrowser {

	private final RhinoBox box;

	public RhinoBrowser(RhinoBox box) {
		this.box = box;
		configureEnvjs();
	}

	private void configureEnvjs() {
		Object window = box.getScope().get("window");
		if (window == null || UniqueTag.NOT_FOUND.equals(window)) {
			box.source("rhinobox/server/env.rhino.js");
			box.source("rhinobox/server/configure.js");
		}
	}

	public RhinoBox getBox() {
		return box;
	}

	public void open(URL resource) {
		String url = PathUtil.toUrl(resource);
		box.eval("window.location = '" + url + "'", getClass());
	}

	public static void main(String[] args) {
	}

	public void openSimplePage() {
		open(getClass().getResource("main.html"));
	}

}
