package com.googlecode.mycontainer.commons.rhino;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mozilla.javascript.Scriptable;

public class RhinoScope implements Serializable {

	private static final long serialVersionUID = -8846535241936717397L;

	private final Scriptable scope;

	public RhinoScope(Scriptable scope) {
		this.scope = scope;
	}

	public Scriptable getScope() {
		return scope;
	}

	public Object get(String key) {
		return scope.get(key, scope);
	}

	public void set(String key, Object value) {
		scope.put(key, scope, value);
	}

	public List<String> getKeys() {
		Object[] ids = scope.getIds();
		List<String> ret = new ArrayList<String>(ids.length);
		for (Object object : ids) {
			ret.add((String) object);
		}
		return ret;
	}

	public Map<String, Object> getAll() {
		List<String> keys = getKeys();
		Map<String, Object> ret = new HashMap<String, Object>();
		for (String key : keys) {
			Object value = get(key);
			ret.put(key, value);
		}
		return ret;
	}

}
